<template>
  <div class="edit-group-name-container">
    <div class="group-deatail-header">
      <div class="top-bar">
        <div class="more-container">
          <img
            @click="editGroupTitle"
            style="margin: 0 10px; width: 20px"
            src="/Images/tabs/check.svg"
          />
        </div>
        <div class="back-container">
          <span>{{ $t('tabs.message.group.editname') }}</span>
          <img
            style="
              width: 18px;
              margin-top: 5px;
              margin-left: 5px;
              margin-right: 5px;
            "
            src="/Images/tabs/arrow-right.svg"
            @click="back"
          />
        </div>
      </div>
    </div>
    <div class="content-container" dir="rtl">
      <img
        :src="groupAvatar"
        alt="image"
        class="group-avatar-image"
        v-if="hasAvatar"
      />
      <div class="group-avatar" v-else>
        {{ groupAvatar }}
      </div>
      <input
        type="file"
        style="display: none"
        ref="file"
        @change="updloadAvatar($event.target)"
      />
      <div class="input-container">
        <input
          v-model="title"
          type="text"
          :placeholder="t('tabs.message.enternamegroup')"
        />
        <img
          @click="showEmojy = !showEmojy"
          src="/Images/tabs/emojies.svg"
          alt="icon"
          style="margin-right: 10px"
        />
      </div>
    </div>
    <!-- <EmojiPicker :native="true" v-if="showEmojy" @select="onSelectEmoji" /> -->
    <div class="upload-photo" dir="rtl">
      <img src="/Images/tabs/camera.svg" alt="icon" @click="openFile" />
      <div class="text" @click="openFile">
        <span>{{ t('tabs.message.group.selectavatar') }}</span>
      </div>
    </div>
    <ion-toast
      :is-open="toastIsOpen"
      :message="t('tabs.message.group.validationErrors.required')"
      :duration="5000"
      dir="rtl"
    ></ion-toast>
  </div>
</template>

<script setup>
import { useUserStore } from '@/store/user/user';
import { getFile } from '@/helpers/parser.js';
import { fileUploader } from '@/api/file/index.js';
import { useGroupChat } from '@/store/chats/groupChat';
import { modalController, IonToast } from '@ionic/vue';
import { ref, onMounted, computed } from 'vue';
import { useOverallChatsStore } from '@/store/chats/overall.js';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();

const overallChatsStore = useOverallChatsStore();

const hasAvatar = ref(false);
const showEmojy = ref(false);
const toastIsOpen = ref(false);
const userStore = useUserStore();
const groupChatStore = useGroupChat();
const uploadLoading = ref(false);
const title = ref('');
const file = ref();

const back = () => {
  modalController.dismiss();
};

const openFile = () => {
  file.value.click();
};

const updloadAvatar = async (event) => {
  uploadLoading.value = true;
  const fileId = await fileUploader(event.files[0]);
  const blobAvatar = await getFile(fileId, userStore.token, 'image');
  groupChatStore.currentGroup.avatar = blobAvatar.filePath;
  await groupChatStore.updateAvatar(fileId);
  uploadLoading.value = false;
};

const groupAvatar = computed(() => {
  if (groupChatStore.currentGroup.avatar == '') {
    hasAvatar.value = false;
    return groupChatStore.currentGroup.title.slice(0, 1).toUpperCase();
  } else {
    hasAvatar.value = true;
    return groupChatStore.currentGroup.avatar;
  }
});

const editGroupTitle = async () => {
  if (title.value.length === 0) {
    toastIsOpen.value = true;
  } else {
    toastIsOpen.value = false;
    modalController.dismiss();
    await groupChatStore.editTitleGroup(title.value).then(async (res) => {
      await overallChatsStore.getChatList();
    });
  }
};

const onSelectEmoji = () => {};

onMounted(() => {
  title.value = groupChatStore.currentGroup.title;
});
</script>

<style scoped>
.edit-group-name-container {
  width: 100%;
}

.group-deatail-header {
  width: 100%;
  height: 10vh;
  display: flex;
  flex-direction: column;
  justify-content: center;
  background-color: #428cff;
  padding: 0px 10px;
}

.top-bar {
  width: 100%;
  display: flex;
}

.back-container {
  width: 60%;
  display: flex;
  justify-content: end;
  align-items: center;
}

.more-container {
  width: 40%;
  display: flex;
  justify-content: start;
}

.back-container span {
  color: #fff;
  font-size: 27px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}

.content-container {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 20px 20px;
}

.group-avatar-image {
  width: 100px;
  height: 100px;
  border-radius: 50%;
}

.group-avatar {
  width: 100px;
  height: 85px;
  border-radius: 50%;
  background-color: #8377ee;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 22px;
  font-weight: 600;
  color: #fff;
}

.input-container {
  width: 260px;
  display: flex;
  justify-content: center;
  align-items: center;
  border-bottom: 1px solid #cecbcb;
  margin: 0 5px;
  padding: 10px 0;
}

.input-container input {
  border: none;
  border-radius: 0;
  height: 30px;
  width: 90%;
  outline: none;
  background: none;
}

.upload-photo {
  display: flex;
  padding: 10px 36px;
}

.text {
  color: #0066ff;
  font-size: 20px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  margin-top: 10px;
  margin-left: 15px;
  margin-right: 15px;
}
</style>
